unit ExtractionMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.StdCtrls, Vcl.ExtCtrls, system.Math,
  system.UITypes, Vcl.Grids, System.UIConsts;

type
  D2array = array of array of Double;

  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    ExtractBtn: TButton;
    FileSaveBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    Timer1: TTimer;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    ScrollBox2: TScrollBox;
    Image2: TImage;
    GroupBox1: TGroupBox;
    PointXEdit: TLabeledEdit;
    PointYEdit: TLabeledEdit;
    HueEdit: TLabeledEdit;
    GroupBox2: TGroupBox;
    ExtHueEdit: TLabeledEdit;
    RangeEdit: TLabeledEdit;
    CheckBox1: TCheckBox;
    LightEdit: TLabeledEdit;
    SatEdit: TLabeledEdit;
    CheckBox2: TCheckBox;
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ExtractBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1DblClick(Sender: TObject);
  private
    { Private 錾 }
    procedure Imageout(Image: TBitmap; ImageNo: integer; magnification: double);
    procedure Extraction;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
type
  TAlphaarry = array[0..0] of TAlphaColor;    // TAlphaColorzCadinal
  PAlphaarray = ^TAlphaarry;                  // z̃|C^[

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHWC   = 440;    // \gTCY

  Laplacian     = 0;
  Gaussians     = 1;
  Deconvolution = 2;
  Unsharp       = 3;

var
  InputDBitmap  : TBitmap;                    // ̓f[^[\prbg}bv
  OutputBitmap  : TBitmap;                    // ]摜\prbg}bv
  GHeight       : Integer;                    // ̓f[^[摜
  GWidth        : Integer;                    // ̓f[^[摜

  VRect         : Trect;                      // \TCYݒp
  InFilename    : string;                     // ̓t@C
  HueMat        : D2array;
  SatMat        : D2array;
  LitMat        : D2array;

  Xpos, Ypos    : Integer;

// w摜̐Foopf[^[ɃZbg
procedure TForm1.Image1DblClick(Sender: TObject);
begin
  ExtHueEdit.Text    := FloatTostrF(HueMat[Ypos, Xpos], ffFixed, 4, 1);
end;

// }EẌʒu̐Ff[^[\
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Xpos := X;
  Ypos := Y;
  PointXEdit.Text := intTostr(Xpos);
  PointYEdit.Text := intTostr(Ypos);
  HueEdit.Text    := FloatTostrF(HueMat[Ypos, Xpos], ffFixed, 4, 1);
end;

//------------------------
// ϔ{o
//------------------------
procedure TForm1.Imageout(Image: TBitmap; ImageNo: integer; magnification: double);
var
  Rect0           : Trect;
  MW, MH          : Integer;
begin
  MW := Round(GWidth * magnification);
  MH := Round(GHeight * magnification);
  Rect0 := Rect(0, 0, MW, MH);
  if ImageNo = 1 then begin
    Image1.Width := MW;
    Image1.Height := MH;
    Image1.Picture.Bitmap.SetSize(MW, MH);
    Image1.Canvas.StretchDraw(Rect0, Image);                // o͘gɕϔ{o
  end;
  if ImageNo = 2 then begin
    Image2.Width := MW;
    Image2.Height := MH;
    Image2.Picture.Bitmap.SetSize(MW, MH);
    Image2.Canvas.StretchDraw(Rect0, Image);                // o͘gɕϔ{o
  end;
end;

//--------------------------------------
// tB^[vZ^C}[x
// {^̕\؂ւVCLs̎ԑ҂
//--------------------------------------
procedure TForm1.ExtractBtnClick(Sender: TObject);
begin
  FileOpenBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  Timer1.Enabled := True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  Extraction;
  FileSaveBtn.Enabled := True;
  FileOpenBtn.Enabled := True;
end;

//-------------------------------------
// Color Extraction
// wF̎o
//-------------------------------------
procedure TForm1.Extraction;
const
  Wp = 4;
var
  Hsl, HSLHi, HSLLo : double;
  Hsd               : double;
  X, Y              : integer;
  Inp               : PAlphaarray;
  Oup               : PAlphaarray;
  Hue               : Double;
  Huef              : Boolean;
  CAlpha            : TAlphaColor;
  SatTH             : double;
  LitTH             : double;
begin
  val(ExtHueEdit.Text, Hsl, X);
  if X <> 0 then begin
    Application.MessageBox('Fpx̓͒lɌ肪܂B','F',0);
    exit;
  end;
  if (Hsl < 0) or (Hsl > 360) then begin
    Application.MessageBox('Fpx͈̔͂͂OFRUOłB','F',0);
    exit;
  end;
  val(RangeEdit.Text, Hsd, X);
  if X <> 0 then begin
    Application.MessageBox('F͈͂̓͒lɌ肪܂B','͈',0);
    exit;
  end;
  if (Hsd < 0) or (Hsd > 180) then begin
    Application.MessageBox('͈͊px͈̔͂͂Ó͈PWOłB','͈',0);
    exit;
  end;
  val(SatEdit.Text,   SatTH, X);
  if X <> 0 then begin
    Application.MessageBox('ʓx̓͒lɌ肪܂B','ʓx',0);
    exit;
  end;
  if (SatTH < 0) or (SatTH > 1) then begin
    Application.MessageBox('ʓx臒l͈̔͂͂O臒lPłB','ʓx',0);
    exit;
  end;
  val(LightEdit.Text, LitTH, X);
  if X <> 0 then begin
    Application.MessageBox('Px臒l̓͒lɌ肪܂B','Px',0);
    exit;
  end;
  if (LitTH < 0) or (LitTH > 1) then begin
    Application.MessageBox('Px臒l͈̔͂͂O臒lPłB','Px',0);
    exit;
  end;
  // w肳ꂽFAʓxAPxɂ摜̒o
  HSLHi := Hsl + Hsd;                                             // F
  if HSLHi > 360 then HSLHi := HSLHi - 360;
  HSLLo := Hsl - Hsd;                                             // F
  if HSLLo < 0   then HSLLo := HSLLo + 360;
  for Y := 0 to Gheight - 1 do begin
    Inp := InputDBitmap.ScanLine[Y];
    Oup := OutputBitmap.ScanLine[Y];
    for X := 0 to GWidth - 1 do begin
      Huef := False;
      Hue := HueMat[Y, X];
      // Fw肳ꂽ͈͂ɓĂ邩mFtOZbg
      if HSLHi >= HSLLo then begin
        if (Hue <= HSLHi) and (Hue >= HSLLo) then Huef := True;
      end
      else begin
        if (Hue < HSLHi)  or (Hue > HSLLo)   then Huef := True;
      end;
      // ʓxmF
      if SatTH > SatMat[Y, X] then Huef := False;
      // PxmF
      if LitTH > LitMat[Y, X] then Huef := False;
      // ôŖΕ_
      if CheckBox1.Checked then Huef := not Huef;
      // True łΎw蕔摜f[^[o
      if Huef then CAlpha := inp[X]
              else begin
                // w蕔ȊO𔒂ɂ邩ɂ邩Zbg
                if CheckBox2.Checked then CAlpha := $00000000
                                     else CAlpha := $00FFFFFF;
              end;
      // o͗pC[Wɏ
      Oup[X] := CAlpha;
    end;
  end;
  Imageout(OutputBitmap, 2, 1);                                 // o͘gɕϔ{o
end;

//---------------------------------------------------
// t@C̃I[vƐFf[^[ϊ
//---------------------------------------------------
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  X, Y        : Integer;
  PBA         : PAlphaarray;
  CAlpha      : TAlphaColor;
  hf, Sf, Lf  : single;
begin
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute = true then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        Image1.Width := GWidth;
        Image1.Height:= GHeight;
        Image1.Picture.Bitmap.SetSize(GWidth, GHeight);
        InputDBitmap.Width := GWidth;
        InputDBitmap.Height := GHeight;
        InputDBitmap.Canvas.Draw(0, 0, WIC);                  // rbg}bvɕ`tH[}bgϊ
        Image2.Picture.Bitmap.SetSize(GWidth, GHeight);
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  OutputBitmap.Width  := GWidth;
  OutputBitmap.Height := GHeight;
  // FAʓxAPx̔zm
  setLength(HueMat, GHeight, GWidth);
  setLength(SatMat, GHeight, GWidth);
  setLength(LitMat, GHeight, GWidth);
  // RGB to HSL ϊ
  for Y := 0 to Gheight - 1 do begin
    PBA := InputDBitmap.ScanLine[Y];
    for X := 0 to GWidth - 1 do begin
      CAlpha := PBA[X];                                       // TAlphaColor̎擾
      RGBtoHSL(CAlpha, Hf, Sf, lf);                           // HSL ϊ
      HueMat[Y, X] := Hf * 360;
      SatMat[Y, X] := Sf;
      LitMat[Y, X] := lf;
    end;
  end;
  Imageout(InputDBitmap, 1, 1);                               // o͘gɕϔ{o
  ExtractBtn.Enabled := True;
end;

//------------------------------
// 摜̃t@Cւ̕ۑ
//------------------------------
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                            // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');   // gq̐ݒ
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');   // gq̐ݒ
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');   // gq̐ݒ
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');   // gq̐ݒ
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                         // gqo
  if not WFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                      // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                          // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                 // TWicImage
  try
    WIC.Assign(OutputBitmap);                                              // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                               // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                 // t@C̏o
  finally
    WIC.Free;                                                              // TWicImage
  end;
end;

//----------------
// ݒ
//----------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  Timer1.Enabled := False;
  Image1.Width  := ImageHWC div 2;
  Image1.Height := ImageHWC div 2;
  ScrollBox1.Height := ImageHWC;
  ScrollBox1.Width  := ImageHWC;
  Image1.Top := 0;
  Image1.Left := 0;
  Image2.Width  := ImageHWC div 2;
  Image2.Height := ImageHWC div 2;
  ScrollBox2.Height := ImageHWC;
  ScrollBox2.Width  := ImageHWC;
  Image2.Top := 0;
  Image2.Left := 0;
  InputDBitmap  := TBitmap.Create;
  OutputBitmap  := TBitmap.Create;
  InputDBitmap.PixelFormat := pf32bit;
  OutputBitmap.PixelFormat := pf32bit;
  ExtractBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
end;

//----------------
// I
//----------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;
  OutputBitmap.Free;
end;


end.
